<template>
  <div>
    <v-divider></v-divider>
    <div class="">
    
      <div class="textoFooter">
        El semáforo de evaluación considera el código de colores establecido en
        el Manual de Certificación de Sucursal
      </div>
      <div class="divSemaforo">
        <template v-for="(itemRango, indexItemRango) in rangos">
          <div :key="indexItemRango" class="semaforo">
            <div
              :style="'background-color:' + itemRango.detalle"
              class="cuadroSemaforo"
            ></div>
            <div class="textoSemaforo">
              {{ itemRango.valor_rango }} {{ itemRango.limite_inferior }}% -
              {{
                itemRango.limite_superior === 1000
                  ? 100
                  : itemRango.limite_superior
              }}%
            </div>
          </div>
        </template>
      </div>
    </div>
  </div>
</template>
<style scoped>
.fixd-height {
  height: 114px;
}
.pRelative {
  position: relative;
}
.divFooter {
  width: 100%;
  padding: 24px 15px;
  box-sizing: border-box;
  background-color: #ffffff;
  -webkit-box-shadow: 1px -8px 3px -5px rgba(153, 150, 150, 0.87);
  -moz-box-shadow: 1px -8px 3px -5px rgba(153, 150, 150, 0.87);
  box-shadow: 1px -8px 3px -5px rgba(153, 150, 150, 0.87);
  position: fixed;
  bottom: 14px;
  box-sizing: border-box;
  left: 0;
  z-index: 9;
}
.textoFooter {
  text-align: center;
  font-size: 12px;
  color: #9c9b9b;
  font-family: "Avenir_Next_Demi_Bold";
}
.divSemaforo {
  margin-top: 15px;
  width: 100%;
  display: flex;
  flex-wrap: wrap;
  justify-content: space-around;
}
.semaforo {
  display: flex;
  align-items: center;
  width: 20%;
}
.cuadroSemaforo {
  width: 20px;
  height: 20px;
}
.cuadroNegro {
  background-color: #000;
}
.cuadroRojo {
  background-color: #ea5374;
}
.cuadroAmarillo {
  background-color: #f4c65c;
}
.cuadroVerde {
  background-color: #a2cc84;
}

.textoSemaforo {
  font-size: 14px;
  color: #000;
  font-family: "Avenir_Next_Demi_Bold", sans-serif;
  padding: 5px 8px;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
export default {
  name: "Component-Semaforo",
  components: {
  },
  data() {
    return {
      rangos: [],
    };
  },
  methods: {
    getRangos() {
      var self = this;
      axios
        .get("franquicia/rango/secure/get/numero/8")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setRangos(data);
                self.$root.$emit("rangoloaded", {
                  getRangoByLimit: self.getRangoByLimit,
                  getRangoById: self.getRangoById,
                });
              }
            } else {
              self.setRangos([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    setRangos(data) {
      this.rangos = data;
    },
    getRangoByLimit(value) {
      const rango = this.rangos.filter((itemRango) => {
        if (
          value >= itemRango.limite_inferior &&
          value <= itemRango.limite_superior
        ) {
          return itemRango;
        }
      })[0];
      return rango;
    },
    getRangoById(idRango) {
      const rango = this.rangos.filter(
        (itemRango) => itemRango.id_rango === idRango
      )[0];
      /*Se requiere implementar una modificación en el servicio para actualizar el semaforo 
      De momento si es inferior a id_rango 2 es por que no cumple. 
      Rango anterior: 
        1 - Daño Economico  ;     0 - 50
        2 - No cumple       ;     51 - 69
        3 - Debajo del objetivo;  70 - 89
        4 - Cumple    ;           90 - 100

      Rango actual 3Q 2020
        61 - No cumple ;          0 - 69
        62 - Debajo del objetivo; 70 - 89
        63 - Cumple     ;         90 - 100

        PENDIENTE
    
      let idRango3Q = 0;

      if (idRango <= 2){
        idRango3Q = 61;
      }else{

        if (idRango === 3){
          idRango3Q = 62;
        }else{
           idRango3Q = 63;
        }
        
      }

      const rango = this.rangos.filter(
        (itemRango) => itemRango.id_rango === idRango3Q
      )[0];*/

      return rango;
    },
  },
  destroyed() {
    this.$root.$off("rangoloaded");
  },
  created() {
    this.getRangos();
  },
};
</script>
